package cv2;
 
import cv2.servis.BasicServis;
import cv2.servis.MountainBikeBasicServis;
import cv2.servis.RoadBikeBasicServis;
 
public class TestBikes {
    public static void main(String[] args) {
        Bicycle bike01, bike02, bike03;
 
        bike01 = new Bicycle(20, 10, 1);
        bike02 = new MountainBike(20, 10, 5, "Dual");
        bike03 = new RoadBike(40, 20, 8, 23);
 
        bike01.printDescription();
        bike02.printDescription();
        bike03.printDescription();
 
        BasicServis servis1 = new BasicServis();
        BasicServis servis2 = new MountainBikeBasicServis();
        BasicServis servis3 = new RoadBikeBasicServis();
 
        System.out.println("\nSingle dispatch");
        // prvni pokus - nefunguke
        servis1.accept(bike01);
        servis2.accept(bike02);
        servis3.accept(bike03);
 
        System.out.println("\nDouble dispatch");
        // druhy pokus
        bike01.visit(servis1);
        bike02.visit(servis2);
        bike03.visit(servis3);
    }
}
